diff --git a/arch/powerpc/cpu/mpc5xxx/start.S b/arch/powerpc/cpu/mpc5xxx/start.S
index 84ab41e..02c706e 100644
--- a/arch/powerpc/cpu/mpc5xxx/start.S
+++ b/arch/powerpc/cpu/mpc5xxx/start.S
@@ -14,8 +14,6 @@
 #include <mpc5xxx.h>
 #include <version.h>
 
-#define CONFIG_MPC5xxx 1	/* needed for Linux kernel header files */
-
 #include <ppc_asm.tmpl>
 #include <ppc_defs.h>
 
diff --git a/include/configs/BC3450.h b/include/configs/BC3450.h
index 377db7b..ad69d33 100644
--- a/include/configs/BC3450.h
+++ b/include/configs/BC3450.h
@@ -22,7 +22,6 @@
 /*
  * High Level Configuration Options
  */
-#define CONFIG_MPC5xxx		1	/* This is an MPC5xxx CPU	    */
 #define CONFIG_MPC5200		1	/* (more precisely a MPC5200 CPU)   */
 #define CONFIG_TQM5200		1	/* ... on a TQM5200 module	    */
 
diff --git a/include/configs/IceCube.h b/include/configs/IceCube.h
index 52368f8..ca49a99 100644
--- a/include/configs/IceCube.h
+++ b/include/configs/IceCube.h
@@ -13,7 +13,6 @@
  * (easy to change)
  */
 
-#define CONFIG_MPC5xxx		1	/* This is an MPC5xxx CPU */
 #define CONFIG_MPC5200		1	/* (more precisely a MPC5200 CPU) */
 #define CONFIG_ICECUBE		1	/* ... on IceCube board */
 
diff --git a/include/configs/MVBC_P.h b/include/configs/MVBC_P.h
index 9d49de7..99e4e90 100644
--- a/include/configs/MVBC_P.h
+++ b/include/configs/MVBC_P.h
@@ -13,7 +13,6 @@
 
 #include <version.h>
 
-#define CONFIG_MPC5xxx	1
 #define CONFIG_MPC5200 	1
 
 #ifndef CONFIG_SYS_TEXT_BASE
diff --git a/include/configs/MVSMR.h b/include/configs/MVSMR.h
index f69b9a8..bb565b6 100644
--- a/include/configs/MVSMR.h
+++ b/include/configs/MVSMR.h
@@ -13,7 +13,6 @@
 
 #include <version.h>
 
-#define CONFIG_MPC5xxx	1
 #define CONFIG_MPC5200 	1
 
 #ifndef CONFIG_SYS_TEXT_BASE
diff --git a/include/configs/PM520.h b/include/configs/PM520.h
index 557a8ba..767ffdc 100644
--- a/include/configs/PM520.h
+++ b/include/configs/PM520.h
@@ -14,7 +14,6 @@
  */
 
 #define CONFIG_MPC5200
-#define CONFIG_MPC5xxx		1	/* This is an MPC5xxx CPU */
 #define CONFIG_PM520		1	/* ... on PM520 board */
 
 #define	CONFIG_SYS_TEXT_BASE	0xfff00000
diff --git a/include/configs/TB5200.h b/include/configs/TB5200.h
index 90f7fc4..af550aa 100644
--- a/include/configs/TB5200.h
+++ b/include/configs/TB5200.h
@@ -16,7 +16,6 @@
  * (easy to change)
  */
 
-#define CONFIG_MPC5xxx		1	/* This is an MPC5xxx CPU */
 #define CONFIG_MPC5200		1	/* (more precisely an MPC5200 CPU) */
 #define CONFIG_TQM5200		1	/* ... on TQM5200 module */
 #define CONFIG_TB5200		1	/* ... on a TB5200 base board */
diff --git a/include/configs/TOP5200.h b/include/configs/TOP5200.h
index 7aba009..e19201f 100644
--- a/include/configs/TOP5200.h
+++ b/include/configs/TOP5200.h
@@ -25,7 +25,6 @@
  * (easy to change)
  */
 
-#define CONFIG_MPC5xxx		1	/* This is an MPC5xxx CPU */
 #define CONFIG_MPC5200		1	/* More exactly a MPC5200 */
 #define CONFIG_TOP5200		1	/* ... on TOP5200 board - we need this for FEC.C */
 
diff --git a/include/configs/TQM5200.h b/include/configs/TQM5200.h
index 13500ee..2f91840 100644
--- a/include/configs/TQM5200.h
+++ b/include/configs/TQM5200.h
@@ -16,7 +16,6 @@
  * (easy to change)
  */
 
-#define CONFIG_MPC5xxx		1	/* This is an MPC5xxx CPU		*/
 #define CONFIG_MPC5200		1	/* (more precisely an MPC5200 CPU)	*/
 #define CONFIG_TQM5200		1	/* ... on TQM5200 module		*/
 #undef CONFIG_TQM5200_REV100		/*  define for revision 100 modules	*/
diff --git a/include/configs/Total5200.h b/include/configs/Total5200.h
index acc4fdc..d76235e 100644
--- a/include/configs/Total5200.h
+++ b/include/configs/Total5200.h
@@ -24,7 +24,6 @@
  * (easy to change)
  */
 
-#define CONFIG_MPC5xxx		1	/* This is an MPC5xxx CPU */
 #define CONFIG_MPC5200		1	/* (more precisely a MPC5200 CPU) */
 #define CONFIG_TOTAL5200	1	/* ... on Total5200 board */
 
diff --git a/include/configs/a3m071.h b/include/configs/a3m071.h
index d151869..1c2ac3a 100644
--- a/include/configs/a3m071.h
+++ b/include/configs/a3m071.h
@@ -13,7 +13,6 @@
  */
 
 #define CONFIG_MPC5200
-#define CONFIG_MPC5xxx		1	/* This is an MPC5xxx CPU */
 #define CONFIG_A3M071			/* ... on A3M071 board */
 
 #define	CONFIG_SYS_TEXT_BASE	0x01000000	/* boot low for 32 MiB boards */
diff --git a/include/configs/a4m072.h b/include/configs/a4m072.h
index 6473702..7ff18ec 100644
--- a/include/configs/a4m072.h
+++ b/include/configs/a4m072.h
@@ -16,7 +16,6 @@
  * (easy to change)
  */
 
-#define CONFIG_MPC5xxx		1	/* This is an MPC5xxx CPU */
 #define CONFIG_MPC5200		1	/* (more precisely a MPC5200 CPU) */
 #define CONFIG_A4M072		1	/* ... on A4M072 board */
 #define CONFIG_MPC5200_DDR	1	/* ... use DDR RAM */
diff --git a/include/configs/aev.h b/include/configs/aev.h
index 0eafb3c..d853419 100644
--- a/include/configs/aev.h
+++ b/include/configs/aev.h
@@ -16,7 +16,6 @@
  * (easy to change)
  */
 
-#define CONFIG_MPC5xxx		1	/* This is an MPC5xxx CPU */
 #define CONFIG_MPC5200		1	/* (more precisely an MPC5200 CPU) */
 #define CONFIG_TQM5200		1	/* ... on TQM5200 module */
 #undef CONFIG_TQM5200_REV100		/*  define for revision 100 modules */
diff --git a/include/configs/canmb.h b/include/configs/canmb.h
index d929bde..3511d10 100644
--- a/include/configs/canmb.h
+++ b/include/configs/canmb.h
@@ -13,7 +13,6 @@
  * (easy to change)
  */
 
-#define CONFIG_MPC5xxx		1	/* This is an MPC5xxx CPU */
 #define CONFIG_MPC5200		1	/* More exactly a MPC5200 */
 #define CONFIG_CANMB		1	/* ... on canmb board - we need this for FEC.C */
 
diff --git a/include/configs/cm5200.h b/include/configs/cm5200.h
index ac3d6bd..1200511 100644
--- a/include/configs/cm5200.h
+++ b/include/configs/cm5200.h
@@ -11,7 +11,6 @@
 /*
  * High Level Configuration Options
  */
-#define CONFIG_MPC5xxx		1	/* This is an MPC5xxx CPU */
 #define CONFIG_MPC5200		1	/* (more precisely an MPC5200 CPU) */
 #define CONFIG_CM5200		1	/* ... on CM5200 platform */
 
diff --git a/include/configs/cpci5200.h b/include/configs/cpci5200.h
index db5cead..d1f2da3 100644
--- a/include/configs/cpci5200.h
+++ b/include/configs/cpci5200.h
@@ -24,7 +24,6 @@
  */
 
 #define CONFIG_MPC5200		1	/* This is an MPC5xxx CPU */
-#define CONFIG_MPC5xxx		1	/* This is an MPC5xxx CPU */
 #define CONFIG_ICECUBE		1	/* ... on IceCube board	  */
 #define CONFIG_CPCI5200		1	/* ... on CPCI5200  board */
 #define CONFIG_MPC5200_DDR	1	/* ... use DDR RAM	  */
diff --git a/include/configs/digsy_mtc.h b/include/configs/digsy_mtc.h
index bc5853e..e2aa0af 100644
--- a/include/configs/digsy_mtc.h
+++ b/include/configs/digsy_mtc.h
@@ -20,7 +20,6 @@
  * High Level Configuration Options
  */
 
-#define CONFIG_MPC5xxx		1	/* This is an MPC5xxx CPU */
 #define CONFIG_MPC5200		1	/* (more precisely an MPC5200 CPU) */
 #define CONFIG_DIGSY_MTC	1	/* ... on InterControl digsyMTC board */
 
diff --git a/include/configs/galaxy5200.h b/include/configs/galaxy5200.h
index 560363d..c200ea9 100644
--- a/include/configs/galaxy5200.h
+++ b/include/configs/galaxy5200.h
@@ -23,7 +23,6 @@
  * High Level Configuration Options
  * (easy to change)
  */
-#define CONFIG_MPC5xxx		1	/* This is an MPC5xxx CPU */
 #define CONFIG_MPC5200		1	/* (more precisely an MPC5200 CPU) */
 #define CONFIG_SYS_MPC5XXX_CLKIN 33333333	/* ... running at 33.333333MHz */
 
diff --git a/include/configs/hmi1001.h b/include/configs/hmi1001.h
index 1c74a2e..20ed1bb 100644
--- a/include/configs/hmi1001.h
+++ b/include/configs/hmi1001.h
@@ -13,7 +13,6 @@
  * (easy to change)
  */
 
-#define CONFIG_MPC5xxx		1	/* This is an MPC5xxx CPU		*/
 #define CONFIG_MPC5200		1	/* (more precisely an MPC5200 CPU)	*/
 #define CONFIG_HMI1001		1	/* HMI1001 board			*/
 
diff --git a/include/configs/inka4x0.h b/include/configs/inka4x0.h
index 608d759..c1cfd56 100644
--- a/include/configs/inka4x0.h
+++ b/include/configs/inka4x0.h
@@ -16,7 +16,6 @@
  * (easy to change)
  */
 
-#define CONFIG_MPC5xxx		1	/* This is an MPC5xxx CPU		*/
 #define CONFIG_MPC5200		1	/* (more precisely an MPC5200 CPU)	*/
 #define CONFIG_INKA4X0		1	/* INKA4x0 board			*/
 
diff --git a/include/configs/ipek01.h b/include/configs/ipek01.h
index 408168b..c17292e 100644
--- a/include/configs/ipek01.h
+++ b/include/configs/ipek01.h
@@ -16,7 +16,6 @@
  */
 
 #define CONFIG_MPC5200
-#define CONFIG_MPC5xxx		1	/* This is an MPC5xxx CPU */
 #define CONFIG_MPX5200		1	/* ... on MPX5200 board */
 #define CONFIG_MPC5200_DDR	1	/* ... use DDR RAM */
 #define CONFIG_IPEK01           	/* Motherboard is ipek01 */
diff --git a/include/configs/jupiter.h b/include/configs/jupiter.h
index 71e8ece..c3a6d7e 100644
--- a/include/configs/jupiter.h
+++ b/include/configs/jupiter.h
@@ -13,7 +13,6 @@
  * (easy to change)
  */
 
-#define CONFIG_MPC5xxx		1	/* This is an MPC5xxx CPU */
 #define CONFIG_MPC5200		1	/* especially an MPC5200 */
 #define CONFIG_JUPITER		1	/* ... on Jupiter board */
 
diff --git a/include/configs/manroland/mpc5200-common.h b/include/configs/manroland/mpc5200-common.h
index 21b17f6..3e4a464 100644
--- a/include/configs/manroland/mpc5200-common.h
+++ b/include/configs/manroland/mpc5200-common.h
@@ -12,7 +12,6 @@
  * High Level Configuration Options
  * (easy to change)
  */
-#define CONFIG_MPC5xxx		1	/* This is an MPC5xxx CPU		*/
 #define CONFIG_MPC5200		1	/* (more precisely an MPC5200 CPU)	*/
 
 #define CONFIG_SYS_MPC5XXX_CLKIN	33000000 /* ... running at 33.000000MHz	*/
diff --git a/include/configs/mcc200.h b/include/configs/mcc200.h
index 1b9e2d0..a236191 100644
--- a/include/configs/mcc200.h
+++ b/include/configs/mcc200.h
@@ -14,7 +14,6 @@
  */
 
 #define CONFIG_MPC5200
-#define CONFIG_MPC5xxx		1	/* This is an MPC5xxx CPU		*/
 #define CONFIG_MCC200		1	/* ... on MCC200 board			*/
 
 /*
diff --git a/include/configs/mecp5200.h b/include/configs/mecp5200.h
index 047e171..68f03ea 100644
--- a/include/configs/mecp5200.h
+++ b/include/configs/mecp5200.h
@@ -24,7 +24,6 @@
  */
 
 #define CONFIG_MPC5200		1	/* This is an MPC5xxx CPU */
-#define CONFIG_MPC5xxx		1	/* This is an MPC5xxx CPU */
 #define CONFIG_ICECUBE		1	/* ... on IceCube board */
 #define CONFIG_MECP5200		1	/* ... on MECP5200  board */
 #define CONFIG_MPC5200_DDR      1       /* ... use DDR RAM      */
diff --git a/include/configs/motionpro.h b/include/configs/motionpro.h
index 8071ac3..c9715d2 100644
--- a/include/configs/motionpro.h
+++ b/include/configs/motionpro.h
@@ -15,7 +15,6 @@
  */
 
 /* CPU and board */
-#define CONFIG_MPC5xxx		1	/* This is an MPC5xxx CPU */
 #define CONFIG_MPC5200		1	/* More exactly a MPC5200 */
 #define CONFIG_MOTIONPRO	1	/* ... on Promess Motion-PRO board */
 
diff --git a/include/configs/munices.h b/include/configs/munices.h
index 3bda8eb..f6ac303 100644
--- a/include/configs/munices.h
+++ b/include/configs/munices.h
@@ -11,7 +11,6 @@
  * High Level Configuration Options
  * (easy to change)
  */
-#define CONFIG_MPC5xxx		1	/* This is an MPC5xxx CPU */
 #define CONFIG_MPC5200		1	/* (more precisely an MPC5200 CPU) */
 #define CONFIG_MPC5200_DDR	1	/* (with DDR-SDRAM) */
 #define CONFIG_MUNICES		1	/* ... on MUNICes board */
diff --git a/include/configs/o2dnt-common.h b/include/configs/o2dnt-common.h
index ce08454..18714ea 100644
--- a/include/configs/o2dnt-common.h
+++ b/include/configs/o2dnt-common.h
@@ -16,7 +16,6 @@
 /*
  * High Level Configuration Options
  */
-#define CONFIG_MPC5xxx		1	/* This is an MPC5xxx CPU */
 #define CONFIG_MPC5200
 
 #define CONFIG_SYS_MPC5XXX_CLKIN	33000000 /* running at 33.000000MHz */
diff --git a/include/configs/pcm030.h b/include/configs/pcm030.h
index 5c61889..6bc195a 100644
--- a/include/configs/pcm030.h
+++ b/include/configs/pcm030.h
@@ -20,7 +20,6 @@
 High Level Configuration Options
 (easy to change)
 -----------------------------------------------------------------------------*/
-#define CONFIG_MPC5xxx		1	/* This is an MPC5xxx CPU */
 #define CONFIG_MPC5200		1	/* (more precisely an MPC5200 CPU) */
 #define CONFIG_MPC5200_DDR	1	/* (with DDR-SDRAM) */
 #define CONFIG_PHYCORE_MPC5200B_TINY 1	/* phyCORE-MPC5200B -> */
diff --git a/include/configs/pf5200.h b/include/configs/pf5200.h
index 327be3f..61bcbbe 100644
--- a/include/configs/pf5200.h
+++ b/include/configs/pf5200.h
@@ -23,7 +23,6 @@
  */
 
 #define CONFIG_MPC5200		1	/* This is an MPC5xxx CPU */
-#define CONFIG_MPC5xxx		1	/* This is an MPC5xxx CPU */
 #define CONFIG_ICECUBE		1	/* ... on IceCube board */
 #define CONFIG_PF5200		1	/* ... on PF5200  board */
 #define CONFIG_MPC5200_DDR	1	/* ... use DDR RAM	*/
diff --git a/include/configs/v38b.h b/include/configs/v38b.h
index 0c54435..7f6b0c7 100644
--- a/include/configs/v38b.h
+++ b/include/configs/v38b.h
@@ -12,7 +12,6 @@
  * High Level Configuration Options
  * (easy to change)
  */
-#define CONFIG_MPC5xxx			1	/* This is an MPC5xxx CPU */
 #define CONFIG_MPC5200			1	/* This is an MPC5200 CPU */
 #define CONFIG_V38B			1	/* ...on V38B board */
 